/*PointerCast.c: Reihenfolge der Byte-Speicherung
 am Bsp. von 11 00000010 00000001 00000000(2) = 50.462.976(10) */

#include <conio.h> //wg. _getch()
#include <stdio.h> //wg. printf()

int main(void)
{          int   bit=0;
  unsigned int  *p2i, i=50462976;
  unsigned char *p2c, c[]={3, 2, 1, 0, 0, 1, 2, 3};

  /*int-Var. i bitweise auslesen und darstellen:*/
  printf ("%u bitweise:\n", i);
  for (bit=0; bit<32; bit++) 
  { if (i & 1<<(31-bit)) printf ("1"); 
    else                 printf ("0"); 
    if (!((bit+1)%8))    printf (" "); 
  } printf ("\n"); 

  /*int-Var. i bytetweise auslesen und darstellen:*/
  p2c = (unsigned char *) &i;
  printf ("p2c[3]=%d p2c[2]=%d p2c[1]=%d p2c[0]=%d\n\n", 
           p2c[3],   p2c[2],   p2c[1],   p2c[0]);

  /*char-Array c[] als int darstellen:*/
  p2i = (unsigned int *) c;
  printf ("(int){3,2,1,0}=%8d \n",     *p2i);
  if (i == *p2i) printf ("Big Endian!"); 
  printf ("\n"); 
  printf ("(int){0,1,2,3}=%8d \n", *(p2i+1)); 
  if (i == *(p2i+1)) printf ("Little Endian!"); 

  printf ("\n\nEnde! (bel. Taste)\n");  _getch();

  return;
}
